#include "handle_events.c"

/* extern const int NUM_JOYS; */
extern int NUM_JOYS;
/* int num_axes; */
extern int* dev_map;

extern struct joy_axis** axes;
extern struct joy_hat** hats;
extern struct joy_button** btns;

extern SDL_Joystick** joys;

void event_loop(SDL_Event event) {

  int done = 0, i = 0, j = 0;
  while (done == 0) {
    /* wait, don't use polling */
    SDL_WaitEvent(&event);

    for (i = 0; i < NUM_JOYS; i++) {
      SDL_Joystick *joy = joys[i];
      int num_axes = SDL_JoystickNumAxes(joys[i]); 
      int num_hats = SDL_JoystickNumHats(joys[i]);
      /* printf("joy %d num_axes: %d, num_hats: %d\n",i,num_axes,num_hats); */
      /* printf("bd: %d bu: %d, ja: %d, jh: %d\n",SDL_JOYBUTTONDOWN,SDL_JOYBUTTONUP,SDL_JOYAXISMOTION,SDL_JOYHATMOTION); */
      for (j = 0; j < num_axes; j = j + 2) { handle_XY_axis(joy,i,j,j + 1); }
      for (j = 0; j < num_hats; j = j + 2) {
        int k = j * 2; handle_hat(joys[i],i,j,k,k+1);
      }
      /* SDL_JoystickClose(joy); */
    }

    switch(event.type) {
    case SDL_JOYBUTTONDOWN:
      i = dev_map[event.jbutton.which];
      handle_button(joys[i], i, event.jbutton.button , 1);
      break;
    case SDL_JOYBUTTONUP:
      i = dev_map[event.jbutton.which];
      handle_button(joys[i], i, event.jbutton.button, 0);
      break;
    case SDL_QUIT:
      /* SDL_JoystickClose(joy); */
      done = 1;
      break;
    default:
      break;
    }
  }
}
