#include <stdio.h>
#include <string.h>
#include <stdlib.h>

extern struct joy_axis** axes;
extern struct joy_hat** hats;
extern struct joy_button** btns;

extern int smooth_refresh;
extern int smooth_algorithm;

void test_configuration() {
  int i;
  for (i = 0; i < NUM_JOYS; i++) {
    if (axes[i][1].axis_id != 0) {
      cfg_map[i] = 1;
    }
    else if (axes[i][1].axis_id == 0) {
      cfg_map[i] = -1;
    }
    else {
      puts("error, config file invalid");
      exit(-1);
    }
  }
}

int read_values(char* filename) {

  /* open file for reading */
  fn = fopen (filename, "r");

  int line_num = 0;
  while (!feof(fn)) {
    char* stype = NULL;
    char line[150];
    char* vals[20];

    int id, axis_id, btn_id, i = 0;

    fgets(line, sizeof line, fn);

    while (strcmp(line,"\n") == 0) {
      puts("skip empty line");
      fgets(line, sizeof line, fn);
      if (feof(fn)) { break; }
    }

    if (feof(fn)) { break; }

    line_num++;

    char *tokenPtr = NULL;
   
    tokenPtr = strtok(line, " "); 
    vals[i] = tokenPtr;

    while (tokenPtr != NULL) { 
      i++;
      tokenPtr = strtok(NULL, ", ");
      vals[i] = tokenPtr;
    }

    stype = vals[0];
    id = atoi(vals[2]);

    if (strcmp(stype, "setting") == 0) {
      if (strcmp(vals[1],"smooth_refresh:") == 0) {
        smooth_refresh = atoi(vals[2]);
        if (verbosity > 0)
          printf("setting smooth_refresh: %d\n",smooth_refresh);
      }
      else if (strcmp(vals[1],"smooth_algorithm:") == 0) {
        smooth_algorithm = atoi(vals[2]);
        if (verbosity > 0)
          printf("setting smooth_refresh: %d\n",smooth_algorithm);
      }
    }
    else if (strcmp(stype, "axis") == 0) {
      axis_id = atoi(vals[4]);
      axes[id][axis_id].joy_id = id;
      axes[id][axis_id].axis_id = axis_id;
      axes[id][axis_id].axis = vals[6][0];
      axes[id][axis_id].min_range = atoi(vals[8]);
      axes[id][axis_id].max_range = atoi(vals[10]);
      axes[id][axis_id].threshold = atoi(vals[12]);
      axes[id][axis_id].keylow = atoi(vals[14]);
      axes[id][axis_id].keyhigh = atoi(vals[16]);
      axes[id][axis_id].type = SDL_JOYAXISMOTION;
    }
    else if (strcmp(stype, "hat") == 0) {
      axis_id = atoi(vals[4]);
      hats[id][axis_id].joy_id = id;
      hats[id][axis_id].axis_id = axis_id;
      hats[id][axis_id].axis = vals[6][0];
      hats[id][axis_id].min_range = atoi(vals[8]);
      hats[id][axis_id].max_range = atoi(vals[10]);
      hats[id][axis_id].threshold = atoi(vals[12]);
      hats[id][axis_id].keylow = atoi(vals[14]);
      hats[id][axis_id].keyhigh = atoi(vals[16]);
      hats[id][axis_id].type = SDL_JOYHATMOTION;
    }
    else if (strcmp(stype, "button") == 0) {
      btn_id = atoi(vals[4]);
      btns[id][btn_id].joy_id = id;
      btns[id][btn_id].button = btn_id;
      btns[id][btn_id].keysym = atoi(vals[6]);
      btns[id][btn_id].type = SDL_JOYBUTTONDOWN;
    }
    else if (stype == NULL) { puts("blargh\n"); }
    else {
      printf("invalid event type %s in configuration file",stype);
      return -1;
    }
  }
  test_configuration();
  return 0;
}
